<template>
  <div>
    <button @click="handleLogOut()" class="x x-fixed-2">log-out</button>
    <base-card>
      <button
        @click="setSelectedTab('stored-resources')"
        :class="{ flat: selectedTab === 'add-resource' }"
      >
        Stored Resources
      </button>
      <button
        @click="setSelectedTab('add-resource'), checkSth()"
        :class="{ flat: selectedTab === 'stored-resources' }"
      >
        Add Resource
      </button>
    </base-card>
    <transition name="slide" mode="out-in">
      <keep-alive>
        <component :is="selectedTab" :resources="storedResources"></component>
      </keep-alive>
    </transition>
  </div>
</template>

<script>
import StoredResources from "./StoredResources.vue";
import AddResource from "./AddResource.vue";
import * as Keycloak from "keycloak-js";

export default {
  mounted() {
    this.login();
  },
  components: {
    StoredResources,
    AddResource,
  },
  created() {
    this.$store.dispatch("getAllResources");
  },
  data() {
    return {
      test: "test",
      selectedTab: "stored-resources",
      // storedResources: null,     // teraz jako computed z vuex.store
    };
  },

  provide() {
    return {
      // resources: this.storedResources,   //provide jest niereaktywny!!! czyli w tym momencie ma null
      addResource: this.addResource,
      removeResource: this.removeResource,
      editResource: this.editResource,
    };
  },

  methods: {
    checkSth() {
      console.log("klik dla testu: ", this.$store.getters.getStoreResource);
    },

    setSelectedTab(tab) {
      this.selectedTab = tab;
    },
    async addResource(title, description, link) {
      const newResource = {
        id: new Date().toISOString(),
        title: title,
        description: description,
        link: link,
      };
      this.$store.dispatch("addOneResource", newResource);
      this.selectedTab = "stored-resources";
    },
    removeResource(resId) {
      console.log("in component. resId: ", resId);
      this.$store.dispatch("deleteOneResource", resId);
      // this.$store.dispatch("getAllResources");     //dziwna rzecz. jak dam te 2 linijki a w storze nic to zadziała.
      // this.$store.dispatch("getAllResources");
    },
    editResource(resId, title, description, link) {
      const updatedResource = {
        resId: resId,
        title: title,
        description: description,
        link: link,
      };
      this.$store.dispatch("editOneResource", updatedResource);
    },
    computed: {
      storedResources() {
        // console.log("computed store", this.$store.state.storedResources);
        return this.$store.getters.getStoreResource;
      },
    },
    // KEYCLOAK FN

    handleLogOut() {
      const MY_REALM = "test";
      const ENCODED_REDIRECT_URI = `${process.env.VUE_APP_BASE_APP_URL}`;
      window.location.replace(
        `${process.env.VUE_APP_BASE_KEYCLOAK_URL}realms/${MY_REALM}/protocol/openid-connect/logout?redirect_uri=${ENCODED_REDIRECT_URI}`
      );
    },
    login() {
      var keycloak = Keycloak({
        realm: `test`,
        url: `${process.env.VUE_APP_BASE_KEYCLOAK_URL}`,
        clientId: `fantastic-app`,
        "ssl-required": "all",
        resource: `fantastic-app`,
        "public-client": true,
        "confidential-port": 0,
      });
      keycloak
        .init({
          // flow: 'implicit',
          promiseType: "native",
          onLoad: "login-required",
        })
        .then((authenticated) => {
          this.$store.commit("TOKEN_SET", authenticated);
          console.log("TOKEN", authenticated);
          return authenticated;
        })
        .catch((error) => {
          console.error(error);
        });
      keycloak.onTokenExpired = () => {
        keycloak
          .updateToken(30)
          .then((refreshed) => {
            if (refreshed) {
              this.$store.commit("TOKEN_SET", keycloak.token);
            } else {
              console.log("Token is still valid");
            }
          })
          .catch((error) => {
            console.error(error);
          });
      };
    },
  },
};
</script>

<style scoped>
div {
  text-align: left;
}
button {
  padding: 0.75rem 1.5rem;
  font-family: inherit;
  background-color: #3a0061;
  border: 1px solid #3a0061;
  color: white;
  cursor: pointer;
  transition: 0.2s;
}

button:hover,
button:active {
  background-color: #270041;
  border-color: #270041;
}

.flat {
  background-color: transparent;
  color: #3a0061;
  border: none;
}

.flat:hover,
.flat:active {
  background-color: #edd2ff;
}

.x {
  margin: 8px;
  padding: 8px;
  cursor: pointer;
  font-weight: bold;
  transition: 0.3s;
  background-color: #edd2ff;
  border: 1px solid #000;
  color: black;
}
.x:hover {
  color: white;
  background-color: #3a0061;
}
.x-fixed-2 {
  position: absolute;
  top: 10px;
  right: 10px;
}

/* starting with transiton */

.slide-enter-active {
  animation: slide-in 0.2s ease-out forwards;
}
.slide-leave-active {
  animation: slide-out 0.2s ease-out forwards;
}

@keyframes slide-in {
  from {
    transform: translateY(-30px);
    opacity: 0;
  }
  to {
    transform: translateY(0px);
    opacity: 1;
  }
}
@keyframes slide-out {
  from {
    transform: translateY(0px);
    opacity: 1;
  }
  to {
    transform: translateY(-30px);
    opacity: 0;
  }
}
</style>
